﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class select : MonoBehaviour {

	//a list of all selectable objects. may have to make it to scan for all selectable objects by tag or name
	//rather then to manually select them. I mean, there may be troops spawining.
	public List<Transform>  selectables;

	//their current positions in screenspace
	public List<Vector3> positionsOnScreen;

	//the selected objects
	List<Transform>  selected;

	//selection
	//the selection rectangle
	Rect selectionRect;
	//first screen position where left mouse button was clicked
	Vector2 originalPos;
	//second screen position where left mouse button was released
	Vector2 finalPos;
	//the reactangle that will be displayed on the screen
	Rect displayRect;

	// Use this for initialization
	void Start () {
		//tranforms the postitions of the selectables from world space to screen space
		//so that we can make calculations with them regarding the selection rectangle
		//(first time)
		positionsOnScreen = new List<Vector3>();
		foreach(Transform objecT in selectables)
		{
			positionsOnScreen.Add(camera.WorldToScreenPoint(objecT.position));
		}
	}
	
	// Update is called once per frame
	void Update () {
		//fromWorldToScreen();
		//selection
		if(Input.GetMouseButtonDown(0))
		{
			//if left mouse button pressed down, record the starting cursor position
			originalPos.x = Input.mousePosition.x;
			originalPos.y = Input.mousePosition.y;
		}
		else if(Input.GetMouseButtonUp(0))
		{
			//if left mouse button released, record the final cursor position
			finalPos.x = Input.mousePosition.x;
			finalPos.y = Input.mousePosition.y;

			//calculate the rectangle made up from the original and final mouse positions
//			selectionRect.xMin = originalPos.x;
//			selectionRect.yMin = originalPos.y;
//			selectionRect.xMax = finalPos.x;
//			selectionRect.yMax = finalPos.y;
			selectionRect = new Rect(Mathf.Min(originalPos.x, finalPos.x), Mathf.Min(originalPos.y, finalPos.y), Mathf.Abs(originalPos.x - finalPos.x), Mathf.Abs(originalPos.y - finalPos.y));
			//the reactangle that will be displayed on the screen
			displayRect = new Rect(Mathf.Min(originalPos.x, finalPos.x), Mathf.Min(Screen.height - originalPos.y, Screen.height - finalPos.y), Mathf.Abs(originalPos.x - finalPos.x), Mathf.Abs((Screen.height - originalPos.y) - (Screen.height - finalPos.y)));

			//check which selectables are grasped with the selection rectangle (according to their pivots)
			foreach(Transform objecT in selectables)
			{
				//if objects is within, change its color so that it is obvious it was selected
				if(selectionRect.Contains(camera.WorldToScreenPoint(objecT.position)))
				{
					objecT.renderer.material.color = Color.green;
				}
			}

		}
	}

	//tranforms the postitions of the selectables from world space to screen space
	//so that we can make calculations with them regarding the selection rectangle
	//although it appears there is absolutely no need for a function like this
//	void fromWorldToScreen()
//	{
//		for(int i = 0;i<selectables.Count;i++)
//		{
//			positionsOnScreen[i] = camera.WorldToScreenPoint(selectables[i].position);
//		}
//	}

	//display of the selection rectangle. for some reason it behaves y-reverse  from the expected and from the actual selection.
	public Texture2D texture;
	void DrawQuad(Rect position, Color color) {
		//Texture2D texture = new Texture2D(1, 1);
		//texture.SetPixel(0,0,color);
		texture.Apply();
		GUI.skin.box.normal.background = texture;
		GUI.skin.box.border = new RectOffset(6,6,6,6);
	
		GUI.Box(position, GUIContent.none);
	}

	void OnGUI () {
		DrawQuad(displayRect, Color.red);
	}

}
